#ifndef SW_IN
#define SW_IN

#define COMPILE_FOR_QCDE

#define MAXPLAYERS 64
#define P_TIDSTART 1000 // Starting TID number
#define COOKIEID 200 // Message number
#define MON_TID 4000 // Ring TID assign beginning number
#define SW_TEMP_BLOOD_TID 900000

#define SW_MAX_FLING_ZDIFF 4.0
#define SW_FLING_COMP 1.25

#define SUMO_ZDIFF 14.0
#define SUMO_SLAMDAMAGE 20
#define SUMO_SLAMDIST 384.0

#define SW_RINGACTOR_TIDADD 15000
#define SW_SERPENTRING_TIDADD 60000 // number derived from => max qcde monster tid around 6k + 15k + 32 x 999 (max possible outcome) is around 52k
#define SW_RINGCOUNT 32
#define SW_SKULLRINGCOUNT 16
#define SW_RING_BASER 4
#define SW_RINGRESOLUTION 1000
#define SW_RING_TARGETOFFSET 36.0
#define SW_SERPENT_MAXSKULLATTACK 3
// 2 << 16
#define SW_RING_PHASEADD 364
#define MAX_SERPENTS_INGAME 256 // nobody puts 256 spider masterminds in their mod...

#define SW_DARKNINJA_FLASHDIST 360.0

#define SW_ZILLA_RAILDENSITY 16

int serpent_count = 0;
bool SerpentRings[MAX_SERPENTS_INGAME][SW_SKULLRINGCOUNT]; // serp tid, serp ring num out of 32. 0 is alive, 1 is dead

enum {
	SW_PAIN_NINJA,
	SW_PAIN_GHOST,
	SW_PAIN_COOLIE,
	SW_PAIN_GUARDIAN,
	SW_PAIN_RIPPER,
	SW_PAIN_RIPPERBABY,
	SW_PAIN_ASSASSIN,
	SW_PAIN_WIZARD,
	SW_PAIN_SUMO,
	SW_PAIN_SERPENT,
	SW_PAIN_YAKUZA,
	SW_PAIN_ZILLA
};

#define MAX_SW_SOUNDAMP SW_PAIN_ZILLA + 1
str SW_SoundAmpList[MAX_SW_SOUNDAMP] = {
	"NinjaBloodSound",
	"GhostBloodSound",
	"CoolieBloodSound",
	"GuardianBloodSound",
	"RipperBloodSound",
	"BabyRipperBloodSound",
	"AssassinBloodSound",
	"WizardBloodSound",
	"SumoBloodSound",
	"SerpentBloodSound",
	"YakuzaBloodSound",
	"ZillaBloodSound"
};

int fdistance (int tid1, int tid2) {
	int len;
	int y = getactory(tid1) - getactory(tid2);
	int x = getactorx(tid1) - getactorx(tid2);
	int z = getactorz(tid1) - getactorz(tid2);

	int ang = vectorangle(x,y);
	if(((ang+0.125)%0.5) > 0.25) len = fixeddiv(y, sin(ang));
	else len = fixeddiv(x, cos(ang));

	ang = vectorangle(len, z);
	if(((ang+0.125)%0.5) > 0.25) len = fixeddiv(z, sin(ang));
	else len = fixeddiv(len, cos(ang));

	return len;
}

int magnitudeThree(int x, int y, int z) {
    return sqrt_z(x*x + y*y + z*z);
}

int sqrt_z(int number)
{
	if(number <= 3)
	{
		if(number > 0)
		{
			return 1;
		}
		return 0;
	}
	
	int oldAns = number >> 1,                     
	    newAns = (oldAns + number / oldAns) >> 1; 
	
	while(newAns < oldAns)
	{
		oldAns = newAns;
		newAns = (oldAns + number / oldAns) >> 1;
	}

	return oldAns;
}

#endif